--Best = 222

local M = {}

local helper = require('scenario/scenariohelper')
local scenarioTimeOut = 0
local startTimer = false
local start = false
local reset = true
local file = require('scenario/fileHandler')
local crystalHandling = require('scenario/crystalHandler')

local function onRaceStart()
	if not start then start = true end
end

local function success(score, team, opponent)
	local medal, nextMedal
	if score < 145 then 
		medal = 'None'
		nextMedal = 'Bronze(145)'
	elseif score >= 145 and score < 155 then 
		medal = 'Bronze'
		nextMedal = 'Silver(155)'
	elseif score >= 155 and score < 165 then 
		medal = 'Silver'
		nextMedal = 'Gold(165)'
	elseif score >= 165 and score < 175 then 
		medal = 'Gold'
		nextMedal = 'Platinum(175)'
	elseif score >= 175 and score < 180 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(180)'
	elseif score >= 180 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.setValueToSave(2, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: ('..team..'-'..opponent..') ='..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'ice' then
		helper.queueLuaCommandByName('player', 'bullettime.set(4)')
		startTimer = true
	elseif data.triggerName == 'crystal_pickup' and data.event == 'enter' then crystalHandling.pickupCrystal(1)
	end
end

local function finish()
	local playerObject = scenetree.findObject('player')
    local car1Object = scenetree.findObject('player1')
    local car2Object = scenetree.findObject('player2')	
	local carOpponentObject = scenetree.findObject('opponent')	
	local distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+563.3, 2) + math.pow(playerObject:getPosition().y+733.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
	local distanceCar1 = math.floor(math.sqrt(math.pow(car1Object:getPosition().x+563.3, 2) + math.pow(car1Object:getPosition().y+733.6, 2), math.pow(car1Object:getPosition().z+0.01, 2)))
	local distanceCar2 = math.floor(math.sqrt(math.pow(car2Object:getPosition().x+563.3, 2) + math.pow(car2Object:getPosition().y+733.6, 2), math.pow(car2Object:getPosition().z+0.01, 2)))
	local distanceOpponent = math.floor(math.sqrt(math.pow(carOpponentObject:getPosition().x+563.3, 2) + math.pow(carOpponentObject:getPosition().y+733.6, 2), math.pow(carOpponentObject:getPosition().z+0.01, 2)))

	local scorePlayer =   math.max(0, 100-distance*2)
	local scoreCar1 =     math.max(0, 100-distanceCar1*2)
	local scoreCar2 =     math.max(0, 100-distanceCar2*2)
	local scoreOpponent = math.max(0, 100-distanceOpponent*2)

	local scoreFinal = scoreCar1+scoreCar2+scorePlayer-scoreOpponent
	success(scoreFinal, scorePlayer+scoreCar1+scoreCar2, scoreOpponent)
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	if startTimer then
		scenarioTimeOut = scenarioTimeOut+raceTickTime
		playerObject:queueLuaCommand('obj:setWind(0, 0, 0)')
	else 
		playerObject:queueLuaCommand('obj:setWind(0, 150, 0)')
	end

	if scenarioTimeOut >= 5 then finish() end
end

local function onScenarioChange(scenario)
	if scenario.state == 'pre-running' then
		if not crystalHandling.spawnCrystal(1) then crystalHandling.removeCrystal() end
	end
end

local function onPreRender(dt)
	if crystalHandling.spawnCrystal(1) then crystalHandling.updateCrystal() end --Only render rotations of the crystal if it is necessary
end

M.onPreRender = onPreRender
M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
return M