--Best = 184

local M = {}

local helper = require('scenario/scenariohelper')
local scenarioTimeOut = 0
local startTimer  = false
local turn1, turn2 = 0, 0
local pendData = ''
local rotation = 0
local player1Finished = false
local file = require('scenario/fileHandler')
local crystalHandling = require('scenario/crystalHandler')

local function success(score, turn1, turn2)
	local medal, nextMedal
	if score < 75 then 
		medal = 'None'
		nextMedal = 'Bronze(75)'
	elseif score >= 75 and score < 100 then 
		medal = 'Bronze'
		nextMedal = 'Silver(100)'
	elseif score >= 100 and score < 150 then 
		medal = 'Silver'
		nextMedal = 'Gold(150)'
	elseif score >= 150 and score < 160 then 
		medal = 'Gold'
		nextMedal = 'Platinum(160)'
	elseif score >= 160 and score < 170 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(170)'
	elseif score >= 170 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.setValueToSave(22, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: ('..turn1..'+'..turn2..') ='..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function updateLevel()
	if pendData == 'way1' then
		TorqueScript.eval('way1barrier.position = "-547.344 -751.424988 0";')
	elseif pendData == 'way2' then
		TorqueScript.eval('way2barrier.position = "-592.088 -789.186 1.25766";')
	elseif pendData == 'way3' then
		TorqueScript.eval('way3barrier.position = "-562.56 -751.067 2.82749";')
	elseif pendData == 'way4' then
		TorqueScript.eval('way4barrier.position = "-543.292 -785.608 3.22146";')
	end
	
	be:reloadStaticCollision();
	pendData = ''
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'ice' then
		helper.queueLuaCommandByName('player', 'bullettime.set(4)')
		startTimer = true
	elseif string.match(data.triggerName, 'way') and not player1Finished then pendData = data.triggerName
	end
end

local function calcScore(turn)
	local playerObject = scenetree.findObject('player')
	local distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+563.3, 2) + math.pow(playerObject:getPosition().y+733.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
	local score = math.max(0, 100-distance*2)
	if     turn == 1 then turn1 = score
	elseif turn == 2 then turn2 = score
	end
end

local function handleTurn()
	if startTimer and not player1Finished then
		calcScore(1)
		updateLevel()
		TorqueScript.eval('player.position = "-561.110962 -1000.08478 0.221231461";')
		TorqueScript.eval('player.rotation = "0 0 -1 0";')
		player1Finished = true
		startTimer = false
		scenarioTimeOut = 0
		helper.queueLuaCommandByName('player', 'bullettime.set(1)')
	elseif player1Finished then 
		calcScore(2)
		success(turn1+turn2, turn1, turn2)
	end
end

local function onRaceTick(raceTickTime)
	if startTimer then
		scenarioTimeOut = scenarioTimeOut+raceTickTime
		scenetree.findObject('player'):queueLuaCommand('obj:setWind(0, 0, 0)')
	else 
		scenetree.findObject('player'):queueLuaCommand('obj:setWind(0, 150, 0)')
	end

	if scenarioTimeOut >= 5 then handleTurn() end
	
	if scenarioTimeOut ~= 0 then ui_message('Time: '..(5-scenarioTimeOut)..'', 2, 'A') end
end

local function onScenarioChange(sc)
	if sc.state == 'pre-running' then
		helper.queueLuaCommandByName('player', 'bullettime.set(1)')
		TorqueScript.eval([[
			way1barrier.position = "10000 0 0";
			way2barrier.position = "10000 0 0";
			way3barrier.position = "10000 0 0";
			way4barrier.position = "10000 0 0";
		]])
	end
end

local function onPreRender(dt)
	rotation = rotation+1
	TorqueScript.eval('rotor.rotation = "1 0 0 '..rotation..'";')
end

M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M