--Best = 300

local M = {}

local rotorRotation = 0
local sawRotation = 0
local angle = 0
local distance = 0
local multiplier = 1
local scoring = false
local timeOut = 0
local file = require('scenario/fileHandler')
local helper = require('scenario/scenariohelper')

local function onScenarioChange(sc)
	if sc.state == 'pre-running' then
		scenetree.findObject('player'):queueLuaCommand('obj:setWind(0, 0, 0)')
		TorqueScript.eval([[
			x2_1_board.position = "-581.63855 -554.020264 384.264801";
			x2_2_board.position = "-566.567261 -752.592957 264.948975";
			x2_3_board.position = "-569.114807 -466.943481 226.544952";
			x2_4_board.position = "-513.750977 -641.771667 472.160706";
			x2_5_board.position = "-618.940918 -666.757202 502.487213";
		]])
	end
end

local function success(scr)
	scoring = false --Prevents scenario ending looping
	local score = scr*multiplier
	
	local medal, nextMedal
	if score < 75 then 
		medal = 'None'
		nextMedal = 'Bronze(75)'
	elseif score >= 75 and score < 100 then 
		medal = 'Bronze'
		nextMedal = 'Silver(100)'
	elseif score >= 100 and score < 150 then 
		medal = 'Silver'
		nextMedal = 'Gold(150)'
	elseif score >= 150 and score < 200 then 
		medal = 'Gold'
		nextMedal = 'Platinum(200)'
	elseif score >= 200 and score < 300 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(300)'
	elseif score >= 300 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end

	file.setValueToSave(21, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: '..scr..'*'..multiplier..' = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if string.find(data.triggerName, 'steam') then
		if     data.event == 'enter' then scenetree.findObject('player'):queueLuaCommand('obj:setWind(0, 555, 0)')
		elseif data.event == 'exit'  then scenetree.findObject('player'):queueLuaCommand('obj:setWind(0, 0, 0)')
		end
	elseif scoring then
		if string.find(data.triggerName, 'target') then success(tonumber(string.match(data.triggerName, "%d+"))) end
	elseif string.find(data.triggerName, 'x2') and data.event == 'enter' then
		TorqueScript.eval(''..data.triggerName..'_board.position = "10000";')
		multiplier = multiplier*2
		helper.flashUiMessage('X2 Got!', 3)
	end
end

local function updateParticles(theta)
	local x, y = 20*math.cos(theta), 20*math.sin(theta)
	TorqueScript.eval([[
		steamCannon1.position = "]]..(-614.218323+x)..[[ -786.179443 ]]..(499.290192+y)..[[";
		steamCannon2.position = "]]..(-507.492462+x)..[[ -786.179443 ]]..(514.696472+y)..[[";
	]])
end

local function onPreRender(dt)
	rotorRotation = rotorRotation+1
	sawRotation = sawRotation+0.5
	TorqueScript.eval([[
		rotor1.rotation =  "1 0  0 ]]..rotorRotation..[[";
		rotor2.rotation =  "1 0  0 ]]..rotorRotation..[[";
		rotor3.rotation =  "1 0  0 ]]..rotorRotation..[[";
		rotor4.rotation =  "1 0  0 ]]..rotorRotation..[[";
		rotor7.rotation =  "0 0 -1 ]]..rotorRotation..[[";
		rotor8.rotation =  "0 0 -1 ]]..rotorRotation..[[";
		rotor9.rotation =  "0 0 -1 ]]..rotorRotation..[[";
		rotor10.rotation = "0 0 -1 ]]..rotorRotation..[[";
		rotor11.rotation = "0 0 -1 ]]..rotorRotation..[[";
		rotor12.rotation = "0 0 -1 ]]..rotorRotation..[[";
		rotor13.rotation = "0 0 -1 ]]..rotorRotation..[[";
		saw1.rotation = "1 0 0 ]].. sawRotation..[[";
		saw2.rotation = "1 0 0 ]]..-sawRotation..[[";
		saw3.rotation = "1 0 0 ]].. sawRotation..[[";
		saw4.rotation = "1 0 0 ]]..-sawRotation..[[";
		saw5.rotation = "1 0 0 ]].. sawRotation..[[";
		saw6.rotation = "1 0 0 ]].. sawRotation..[[";
		saw7.rotation = "1 0 0 ]].. sawRotation..[[";
		saw8.rotation = "1 0 0 ]].. sawRotation..[[";
	]])
	
	angle = angle+dt*2
	updateParticles(angle)
end

local function onRaceTick(raceTickTime)
	local playerData = map.objects[map.objectNames['player']]
	if playerData.vel:length() <= 0.075 and not scoring then scoring = true
	elseif scoring then
		timeOut = timeOut+raceTickTime
		if timeOut > 3 then success(0) end
	end
end

M.onScenarioChange = onScenarioChange
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M