--Best = 2712

local M = {}
local scoreFinal = 0
local scenarioTime = 0
local file = require('scenario/fileHandler')
local helper = require('scenario/scenariohelper')
local targetTime = 0
local targetScore = -1
local rotation = 0

local function onRaceStart()
	if not start then start = true end
end

local function success(score, targetsPoints, timePoints)
	local medal, nextMedal
	if score < 1000 then 
		medal = 'None'
		nextMedal = 'Bronze(1000)'
	elseif score >= 1000 and score < 1500 then 
		medal = 'Bronze'
		nextMedal = 'Silver(1500)'
	elseif score >= 1500 and score < 2000 then 
		medal = 'Silver'
		nextMedal = 'Gold(2000)'
	elseif score >= 2000 and score < 2250 then 
		medal = 'Gold'
		nextMedal = 'Platinum(2250)'
	elseif score >= 2250 and score < 2500 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(2500)'
	elseif score >= 2500 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.setValueToSave(24, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: ('..targetsPoints..'+'..timePoints..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function finish()
	local targetsPoints = scoreFinal
	local timePoints = (600-scenarioTime)*3
	scoreFinal = math.floor(scoreFinal+timePoints)
	success(scoreFinal, targetsPoints, timePoints)
end

local function onBeamNGTrigger(data)
	if data.event == 'enter' and data.triggerName ~= 'finish' then
		local targetPts = tonumber(string.match(data.triggerName, '%d+'))
		targetTime = 0.25
		targetScore = targetScore+targetPts		
		scoreFinal = scoreFinal+targetPts
	elseif data.triggerName == 'finish' then finish()
	end
end

local function onRaceTick(raceTickTime) 
	scenarioTime = scenarioTime+raceTickTime 
	if targetTime > 0 then targetTime = targetTime-raceTickTime
	elseif targetScore ~= -1 then
		helper.flashUiMessage(''..(targetScore+1)..' pts', 2)
		targetScore = -1
	end
end

local function onPreRender(dt)
	rotation = rotation+2
	TorqueScript.eval([[
		rotor1.rotation = "1 0 0 ]]..(rotation*2)..[[";
		rotor2.rotation = "1 0 0 ]]..(rotation*2)..[[";
		rotor3.rotation = "1 0 0 ]]..(rotation*2)..[[";
		rotor4.rotation = "1 0 0 ]]..rotation..[[";
	]])
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M