local M = {}
local portal = require('scenario/portalHandler')
local file = require('scenario/fileHandler')

--Save File: [1]{1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25} - Theme 1-5 
--           [2]{1,2,3,4,5,6} - Singularity, Darts, Curling, Cue, Target, Airborne
--           [3]{1,2,3,4,5,6,7,8,9} - Portal Gems(Green) - 1:2,1:5,2:1,2:4,3:1,3:4,3:5,4:1,4:4

local function updateTrophies(line, digit, rangeLow, diamondCount, achieved)
	if diamondCount ~= nil then
		local emptyPos, trophyPos = "100000 0 0", "-1163.69 -1590.78 3"
		if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
		
		TorqueScript.eval([[
			trophy_diamond_empty.position = "]]..emptyPos..[[";
			trophy_diamond.position = "]]..trophyPos..[[";
		]])
	end
	if digit == nil then
		--Forest
		if rangeLow == 1 then 
			local emptyPos, trophyPos = "100000 0 0", "-695.911987 -1260.14001 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_forest_empty.position = "]]..emptyPos..[[";
				trophy_forest.position = "]]..trophyPos..[[";
			]])
		--Tech
		elseif rangeLow == 6 then 
			local emptyPos, trophyPos = "100000 0 0", "-695.911987 -1330.14001 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_tech_empty.position = "]]..emptyPos..[[";
				trophy_tech.position = "]]..trophyPos..[[";
			]])
		--Space
		elseif rangeLow == 11 then 
			local emptyPos, trophyPos = "100000 0 0", "-695.911987 -1400.14001 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_space_empty.position = "]]..emptyPos..[[";
				trophy_space.position = "]]..trophyPos..[[";
			]])
		--Planets
		elseif rangeLow == 16 then 
			local emptyPos, trophyPos = "100000 0 0", "-695.911987 -1470.14001 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_planets_empty.position = "]]..emptyPos..[[";
				trophy_planets.position = "]]..trophyPos..[[";
			]])
		elseif rangeLow == 21 then 
			local emptyPos, trophyPos = "100000 0 0", "-695.890991 -1543.14001 3";
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_industrial_empty.position = "]]..emptyPos..[[";
				trophy_industrial.position = "]]..trophyPos..[[";
			]])
		end
	else
		--Singularity
		if digit == 1 and line == 2 then 
			local emptyPos, trophyPos = "100000 0 0", "-1163.09 -1519.9 3";
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_singularity_empty.position = "]]..emptyPos..[[";
				trophy_singularity.position = "]]..trophyPos..[[";
			]])
		--Darts
		elseif digit == 2 and line == 2 then
			local emptyPos, trophyPos = "100000 0 0", "-735.906982 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_darts_empty.position = "]]..emptyPos..[[";
				trophy_darts.position = "]]..trophyPos..[[";
			]])
		--Curling
		elseif digit == 3 and line == 2 then
			local emptyPos, trophyPos = "100000 0 0", "-805.906982 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_curling_empty.position = "]]..emptyPos..[[";
				trophy_curling.position = "]]..trophyPos..[[";
			]])
		--Cuegames
		elseif digit == 4 and line == 2 then 
			local emptyPos, trophyPos = "100000 0 0", "-875.906982 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_snooker_empty.position = "]]..emptyPos..[[";
				trophy_snooker.position = "]]..trophyPos..[[";
			]])
		--Targets
		elseif digit == 5 and line == 2 then 
			local emptyPos, trophyPos = "100000 0 0", "-945.906982 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_targets_empty.position = "]]..emptyPos..[[";
				trophy_targets.position = "]]..trophyPos..[[";
			]])
		--Airborne
		elseif digit == 6 and line == 2 then 
			local emptyPos, trophyPos = "100000 0 0", "-1015.90997 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_airborne_empty.position = "]]..emptyPos..[[";
				trophy_airborne.position = "]]..trophyPos..[[";
			]])
		end
	end
end

local function fileCheck_trophy(line, rangeL, rangeU, digit, requirement)	
	local update = true
	if rangeL ~= nil and rangeU ~= nil then --If a theme trophy is being checked then these parameters will not be nil
		--loop through save 'number'
		local medals = file.getLineFromSave(line)
		for i = rangeL, rangeU do
			local number = tonumber(medals:sub(i,i))
			--Do NOT Update THEME trophy if not >= bronze medal
			if number == 0 then 
				update = false
				break 
			end
		end
	else
		local saveValue = file.getValueFromSave(digit, line)
		if saveValue ~= requirement then update = false end
	end
	
	updateTrophies(line, digit, rangeL, nil, update)
end

local function getMedal(num)
	if     num == 1 then return 'bronze'
	elseif num == 2 then return 'silver'
	elseif num == 3 then return 'gold'
	elseif num == 4 then return 'platinum'
	elseif num == 5 then return 'diamond'
	else return 'none'
	end
end

local function fileCheck_medal()
	local file = io.open("cargames_save.txt", "r")
	local medals = file:read()
	file:close()
	
	local diamond = 0
	
	for i = 1, 25 do --25 being event limit (currently)
		local number = tonumber(medals:sub(i,i))
		local xCoord, zCoord = 0, 12.8029
		if     i <= 5  then xCoord = -1138.48+(28*(i-1 ))
		elseif i <= 10 then xCoord = -988.462+(28*(i-6 ))
		elseif i <= 15 then xCoord = -838.487+(28*(i-11)) 
		elseif i <= 20 then 
			xCoord = -1138.48+(28*(i-16))
			zCoord = 41.29774+12.8029
		elseif i <= 25 then
			xCoord = -838.487+(28*(i-21))
			zCoord = 41.29774+12.8029
		end
		
		local numberAsMedal = getMedal(number) --Gets medal from number
		if numberAsMedal == 'diamond' then diamond = diamond+1 end
		
		if numberAsMedal == 'none' then --If no medal achieved then reset all of those medals as a safe-guard
			TorqueScript.eval([[
				]]..getMedal(1)..[[]]..i..[[.position = "10000 0 0";
				]]..getMedal(2)..[[]]..i..[[.position = "10000 0 0";
				]]..getMedal(3)..[[]]..i..[[.position = "10000 0 0";
				]]..getMedal(4)..[[]]..i..[[.position = "10000 0 0";
				]]..getMedal(5)..[[]]..i..[[.position = "10000 0 0";
			]])
		else TorqueScript.eval(numberAsMedal..''..i..'.position = "'..xCoord..' -1236.83997 '..zCoord..'";')
		end
	end
	
	if diamond == 25 then updateTrophies(nil, nil, nil, true, true) 
	else updateTrophies(nil, nil, nil, true, false)
	end
end

local function checkTrophies()
	--Theme Trophies
	fileCheck_trophy(1, 1 ,  5, nil, nil) --Theme 1
	fileCheck_trophy(1, 6 , 10, nil, nil) --Theme 2
	fileCheck_trophy(1, 11, 15, nil, nil) --Theme 3
	fileCheck_trophy(1, 16, 20, nil, nil) --Theme 4
	fileCheck_trophy(1, 21, 25, nil, nil) --Theme 5
	
	--Event Trophies
	fileCheck_trophy(2, nil, nil, 2, 1) --Darts
	fileCheck_trophy(2, nil, nil, 3, 1) --Curling
	fileCheck_trophy(2, nil, nil, 4, 1) --CueGames
	fileCheck_trophy(2, nil, nil, 5, 1) --Targets
	fileCheck_trophy(2, nil, nil, 6, 1) --Airborne
	
	--Misc
	fileCheck_trophy(2, nil, nil, 1, 1) --Singularity
end

local function checkMedals()
	--Checks all medals
	fileCheck_medal()
end

local function onScenarioChange(scenario)
	if scenario.state == 'pre-running' then
		file.checkFileExists()
		
		checkTrophies()
		checkMedals()
		
		
		scenetree.findObject('player'):queueLuaCommand('obj:setGravity(-9.81)')
		TorqueScript.eval([[
			player.position = "-932.465454 -1358.62671 0.125208631";
			platform_2.position = "10000 0 0";
			teleporter_2.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
	end
end

local function onPreRender(dt) portal.update() end

function onBeamNGTrigger(data)
	if string.find(data.triggerName, 'portal') and data.event == 'enter' then
		if data.triggerName == 'portal_hubEnter' then 
			TorqueScript.eval('player.position = "-1013.39 -1512.31 119.41";')
			be:reloadStaticCollision();
		elseif data.triggerName == 'portal_hubReturn' then 
			TorqueScript.eval('player.position = "-927.143677 -1358.62634 0.12413431";')
			be:reloadStaticCollision();
		end
	end
	
	if string.find(data.triggerName, 'p_') and data.event == 'enter' then portal.handleInput(data) end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M